



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Hangfire使用ApplicationInsigts监控</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Hangfire使用ApplicationInsigts监控</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 10:58:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>起因</strong></p>
<p>我司目前使用清真的ApplicationInsights（以下简称Ai）来做程序级监控。（Ai相关文档: <a href="https://azure.microsoft.com/zh-cn/services/application-insights/" rel="external nofollow noreferrer">https://azure.microsoft.com/zh-cn/services/application-insights/</a> ）</p>
<p>其实一切都蛮好的，但是我们基于Hangfire的Job系统却无法被Ai所监控到，因为Ai它监控的原理是基于HttpModule对请求进行监控，而Hangfire则是通过轮询Storage（如Sql或者队列）来实现对Job的处理。</p>
<p>也就是说Hangfire理论上是没有任何对Hangfire站点本身的请求，它类似于自己一个while(true）死循环不断地轮询Storage拿到Job任务就执行。</p>
<p>关于Hangfire的系列可以参考官方的说明 <a href="http://docs.hangfire.io/en/latest/" rel="external nofollow noreferrer">http://docs.hangfire.io/en/latest/</a></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/658343/201804/658343-20180407205910676-84190392.png"></p>
<p>虽说Hangfire自己有个Dashboard可以对Hangfire执行的任务进行监控，如下</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/658343/201804/658343-20180407205911621-1866137958.png"></p>
<p>但是一众的其他站点我全部在Azure的Portal里一目了然，就你一个Hangfire的要我跑到你自己家的Dashboard来看终归不爽，而且也容易忘，导致Hangfire站点常年处于被遗忘的角落。</p>
<p>最近发生了一个Hangfire站点因为某些外部原因没起来（宕掉）的事件之后更加速了要将Hangfire的监控统一到Ai里。</p>
<p><strong>搜索</strong></p>
<p>首先去github上找下有没相关解决方案，老实说觉得基于ai的第三方扩展还是蛮多的，在github搜ai相关的还是能搜索出好几页（<a href="https://github.com/topics/application-insights" rel="external nofollow noreferrer">https://github.com/topics/application-insights</a>），但并没有找到我需要的。</p>
<p>然后google一下找到有人在hangfire论坛里问跟我类似的问题，然而也没有解决方案（<a href="https://discuss.hangfire.io/t/integrating-application-insights-appinsights-into-hangfire/3009" rel="external nofollow noreferrer">https://discuss.hangfire.io/t/integrating-application-insights-appinsights-into-hangfire/3009</a>）。</p>
<p>既然找不到，那干脆自己撸起袖子干。</p>
<p>开干</p>
<p>首先我们回顾下Ai默认自己监控的原理：</p>
<p>前文说了它有个HttpModule会在请求进来的创建一个RequestTelemetry，</p>
<p>并且会在线程上下文内创建个OperationId，然后在该Request的作用于内所有其他数据（如异常/Http请求/Sql请求）都会跟这个Id关联，</p>
<p>这个Id甚至会在你发送Http请求的时候附加在你的Http Header里，然后接收到该Http请求的站点假如也用了Ai的话会根据这个Header里的Id再进行二次关联（调用链路关联）。</p>
<p><strong><em>先解决AI需要的相关基础知识</em></strong></p>
<p>我们要自己在Hangfire里弄AI监控的话，其实重点就是怎么能让Request里的Id能传递到Hangfire里，然后在Hangfire一个操作的作用域里保持该Id一致（串联所有操作）。</p>
<p>那问题重点就清楚了，就是如何解决这个Id的问题。</p>
<p>那Ai自己是如何产生或者获取这个Id的呢，在Ai的2.4版本后引入了对System.Diagnostics.DiagnosticSource这个包的依赖。</p>
<p>所有的Id关联它都基于由此包提供的Activity这个类来事现，详情可以参考 <a href="http://apmtips.com/blog/2018/01/23/diagnosticssource-design-principles/" rel="external nofollow noreferrer">http://apmtips.com/blog/2018/01/23/diagnosticssource-design-principles/</a></p>
<p>如果需要在自己系统里设置一个Id关联的系统的话也强烈推荐使用Activity这个类来进行处理。</p>
<p>别人实现的比自己弄的科学多了，之前我也自己用AsyncLocal来做过，但是后续也都替换成了Activity，</p>
<p>通过<a href="https://github.com/dotnet/corefx/blob/master/src/System.Diagnostics.DiagnosticSource/src/current" rel="external nofollow noreferrer">Activity.Current</a>可以获取到当前的Activity实例，通过new Activity然后调用其Start方法也能快速启动一个Activity，</p>
<p>到此Ai相关所需要的知识就都准备妥当了。</p>
<p><strong><em>然后解决Hangfire需要的相关基础知识</em></strong></p>
<p>从Hangfire的角度来说，它只要提供2个功能支持就可以了。</p>
<p>在任务入队的时候，在数据里面要塞入在当前Request操作的Id，因为我要将Hangfire的操作能够跟Request里相关联起来。</p>
<p>在任务执行的时候，拿到任务数据的时候，要能取出这个Id，然后将这个Id通过Activity进行Start，然后再任务执行完之后要Stop掉这个Activity并释放掉。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/658343/201804/658343-20180407205914084-1457978137.png"></p>
<p>（画的图”有点”丑,但大概就这个意思)</p>
<p>为了解决这个问题查找了下Hangfire全局过滤器相关的资料找到它有IServerFilter和IClientFilter这2个东西：</p>
<p>IServerFilter：服务端处理的过滤器，就是Hangfire Server在执行一个Job的时候要进行处理的过滤器，可在此位置给Hangfire的Job设置Ai的Id到上下文。</p>
<p>IClientFilter:客户端处理的过滤器，就是Hangfire Client在一个Job入队的时候要进行处理的过滤器，可在此位置将Request里的Id赋值给Job Data。</p>
<p>那在Client的时候如何解决每次都能自动塞个Id进去呢？</p>
<p>我的解决思路是定义个JobDtoBase，所有Hangfire任务的数据都要继承自这个类，里面就一个Id，然后通过IClientFilter在每次入队的时候都将当前Activity.Current.Id扔进去</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/658343/201804/658343-20180407205915676-192107271.png"></p>
<p>(需要考虑Acitivity.Current为null的情况）</p>
<p>然后如何在Server端自动将这个Id来启动一个Activity并完成监控呢？</p>
<p>我是想着通过IServerFilter里通过PerformingContext里获取Job的参数然后用is来判断如果是JobDtoBase就取它的Id出来然后启动Activity并创建RequestTelemetry。</p>
<p>重点是在Server这边执行结束之后需要将RequestTelemetry和Activity释放掉，所以通过ThreadStatic的静态变量来对其保持引用。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/658343/201804/658343-20180407205916982-302250849.png"></p>
<p>效果</p>
<p>效果如何这个问题暂时我只能呵呵哒，因为也是刚折腾出来还没投入线上运行。</p>
<p>不过从测试环境来看，确实能抓到我hangfire的请求并在Ai里作为Request进行展示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/658343/201804/658343-20180407205918692-229530318.png"></p>
<p>而且还能抓到依赖项跟”Request”的关联：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/658343/201804/658343-20180407205919285-989318180.png"></p>
<p>所以至少测试的情况来说应该是达到目的了，等之后投入线上后在看下最终具体效果。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93x64g9.html">Less的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ok7np9.html">开发thinkphp的第一步就是给Application目录&lpar;不包括其下的文件&rpar;777权限&comma; 关闭selinux</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyyz72q.html">重温Bootstrap</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2xm639.html">Windows 7个性化配置，关闭Win7动画效果，设置窗口背景为&OpenCurlyDoubleQuote; 豆绿色&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwpnrq.html">java&colon;关于文件下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zxzv3q.html">windows系统下安装MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wz53q.html">MAC机中安装ruby环境--转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3o17q.html">PAT天梯赛练习题 L2-013 红色警报（并查集&plus;逆序加边）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvr561q.html">linux下的汇编环境搭建（nasm）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj7w7k9.html">u-boot移植为tiny6410步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wokdvq.html">SSE2 Intrinsics各函数介绍&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljv1119.html">ExtJs异步无法向外传值和赋值的解决办法，亲测有效</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25eny3q.html">vmware vSphere 5&period;5的14个新功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnn3zkq.html">bashrc  profile的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/902dd3oq.html">Elasticseach的评分机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/963myjy9.html">No&period;4 PyQt学习（页面跳转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnv31eq.html">OpenCV学习笔记&mdash;&mdash;腐蚀与膨胀</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emdjgx9.html">【转】OpenCV Mat数据结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvpxm2q.html">高性能WEB开发：重排与重绘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvegwny9.html">hdu 1300&lpar;dp&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwje1d38.html">python多线程、多进程以及GIL</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jnokl8.html">jquery pjax 用法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zw6r19.html">C&num;封装程序集属性方法注释说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m0vn48.html">es6使用技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjpdmr8.html">CSS&lpar;CSS3&rpar;选择器（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jejw38.html">笔记：Maven 项目目录结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj6j5k8.html">Python之sqlite3</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zvem19.html">蓝牙4&period;0模块控制LED彩灯调光调色经验之谈</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj6ne38.html">安装php扩展 ffmpeg-php</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkjo6e8.html">JavaWeb学习笔记二 Http协议和Tomcat服务器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
